require "util"
require "story"

script.on_init(function()
  global.story = story_init()
  game.forces.player.clear_chart()
  game.forces.player.disable_all_prototypes()
  game.map_settings.enemy_expansion.enabled = false
  game.forces.enemy.evolution_factor = .3
  game.map_settings.enemy_evolution.enabled = false

  local recipe_list = game.forces.player.recipes
  recipe_list["iron-plate"].enabled = true
  recipe_list["copper-plate"].enabled = true
  recipe_list["stone-brick"].enabled = true
  recipe_list["wood"].enabled = true
  recipe_list["stone-furnace"].enabled = true
  recipe_list["iron-stick"].enabled = true
  recipe_list["iron-axe"].enabled = true
  recipe_list["wooden-chest"].enabled = true
  recipe_list["iron-gear-wheel"].enabled = true
  recipe_list["burner-mining-drill"].enabled = true
  recipe_list["transport-belt"].enabled = true
  recipe_list["burner-inserter"].enabled = true
  recipe_list["pipe"].enabled = true
  recipe_list["pipe-to-ground"].enabled = true
  recipe_list["boiler"].enabled = true
  recipe_list["steam-engine"].enabled = true
  recipe_list["electronic-circuit"].enabled = true
  recipe_list["copper-cable"].enabled = true
  recipe_list["pistol"].enabled = true
  recipe_list["firearm-magazine"].enabled = true
  recipe_list["offshore-pump"].enabled = true
  recipe_list["small-electric-pole"].enabled = true
  recipe_list["electric-mining-drill"].enabled = true
  recipe_list["inserter"].enabled = true
  recipe_list["radar"].enabled = true
  recipe_list["lab"].enabled = true
  recipe_list["science-pack-1"].enabled = true
  recipe_list["science-pack-2"].enabled = true
  recipe_list["stone-wall"].enabled = true
  recipe_list["iron-chest"].enabled = true
  recipe_list["repair-pack"].enabled = true
  recipe_list["light-armor"].enabled = true

  local technology_list = game.forces.player.technologies
  technology_list["laser"].enabled = true
  technology_list["flamethrower"].enabled = true
  technology_list["flammables"].enabled = true
  technology_list["modules"].enabled = true
  technology_list["speed-module"].enabled = true
  technology_list["effectivity-module"].enabled = true
  technology_list["productivity-module"].enabled = true
  technology_list["sulfur-processing"].enabled = true
  technology_list["toolbelt"].enabled = true
  technology_list["advanced-electronics"].enabled = true
  technology_list["explosives"].enabled = true
  technology_list["land-mine"].enabled = true
  technology_list["electric-energy-accumulators-1"].enabled = true
  technology_list["laser-turrets"].enabled = true
  technology_list["tanks"].enabled = true
  technology_list["cliff-explosives"].enabled = true
  technology_list["circuit-network"].enabled = true
  technology_list["explosive-rocketry"].enabled = true
  technology_list["night-vision-equipment"].enabled = true
  technology_list["solar-panel-equipment"].enabled = true
  technology_list["energy-shield-equipment"].enabled = true
  technology_list["battery-equipment"].enabled = true
  technology_list["modular-armor"].enabled = true
  technology_list["military-3"].enabled = true
  technology_list["railway"].enabled = true
  technology_list["automated-rail-transportation"].enabled = true
  technology_list["rail-signals"].enabled = true
  technology_list["automobilism"].enabled = true
  technology_list["gates"].enabled = true
  technology_list["rocketry"].enabled = true
  technology_list["engine"].enabled = true
  technology_list["combat-robotics"].enabled = true
  technology_list["battery"].enabled = true
  technology_list["plastics"].enabled = true
  technology_list["fluid-handling"].enabled = true
  technology_list["fluid-wagon"].enabled = true
  technology_list["stack-inserter"].enabled = true
  technology_list["inserter-capacity-bonus-1"].enabled = true
  technology_list["inserter-capacity-bonus-2"].enabled = true

  technology_list["laser-turret-damage-3"].enabled = true
  technology_list["laser-turret-speed-3"].enabled = true
  technology_list["laser-turret-damage-4"].enabled = true
  technology_list["laser-turret-speed-4"].enabled = true
  technology_list["shotgun-shell-damage-4"].enabled = true
  technology_list["shotgun-shell-damage-5"].enabled = true
  technology_list["shotgun-shell-speed-4"].enabled = true
  technology_list["shotgun-shell-speed-5"].enabled = true
  technology_list["rocket-speed-5"].enabled = true
  technology_list["rocket-damage-5"].enabled = true
  technology_list["research-speed-2"].enabled = true
  technology_list["research-speed-3"].enabled = true
  technology_list["research-speed-4"].enabled = true
  technology_list["bullet-damage-3"].enabled = true
  technology_list["bullet-damage-4"].enabled = true
  technology_list["bullet-damage-5"].enabled = true
  technology_list["bullet-speed-3"].enabled = true
  technology_list["bullet-speed-4"].enabled = true
  technology_list["bullet-speed-5"].enabled = true
  technology_list["flamethrower-damage-2"].enabled = true
  technology_list["flamethrower-damage-3"].enabled = true
  technology_list["flamethrower-damage-4"].enabled = true
  technology_list["mining-productivity-1"].enabled = true
  technology_list["gun-turret-damage-2"].enabled = true
  technology_list["gun-turret-damage-3"].enabled = true
  technology_list["gun-turret-damage-4"].enabled = true
  technology_list["gun-turret-damage-5"].enabled = true

  technology_list["steel-processing"].researched = true
  technology_list["optics"].researched = true
  technology_list["logistics"].researched = true
  technology_list["logistics-2"].researched = true
  technology_list["automation"].researched = true
  technology_list["automation-2"].researched = true
  technology_list["electronics"].researched = true
  technology_list["military"].researched = true
  technology_list["military-2"].researched = true
  technology_list["turrets"].researched = true
  technology_list["heavy-armor"].researched = true
  technology_list["advanced-material-processing"].researched = true
  technology_list["solar-energy"].researched = true
  technology_list["electric-energy-distribution-1"].researched = true
  technology_list["stone-walls"].researched = true
  technology_list["oil-processing"].researched = true

  technology_list["rocket-speed-1"].researched = true
  technology_list["rocket-speed-2"].researched = true
  technology_list["rocket-speed-3"].researched = true
  technology_list["rocket-speed-4"].researched = true
  technology_list["rocket-damage-1"].researched = true
  technology_list["rocket-damage-2"].researched = true
  technology_list["rocket-damage-3"].researched = true
  technology_list["rocket-damage-4"].researched = true
  technology_list["bullet-damage-1"].researched = true
  technology_list["bullet-damage-2"].researched = true
  technology_list["bullet-speed-1"].researched = true
  technology_list["bullet-speed-2"].researched = true
  technology_list["laser-turret-damage-1"].researched = true
  technology_list["laser-turret-damage-2"].researched = true
  technology_list["laser-turret-speed-1"].researched = true
  technology_list["laser-turret-speed-2"].researched = true
  technology_list["shotgun-shell-damage-1"].researched = true
  technology_list["shotgun-shell-damage-2"].researched = true
  technology_list["shotgun-shell-damage-3"].researched = true
  technology_list["shotgun-shell-speed-1"].researched = true
  technology_list["shotgun-shell-speed-2"].researched = true
  technology_list["shotgun-shell-speed-3"].researched = true
  technology_list["research-speed-1"].researched = true
  technology_list["flamethrower-damage-1"].researched = true
  technology_list["gun-turret-damage-1"].researched = true

  local lds1 = game.get_entity_by_tag("lds1")
  lds1.insert{name = "low-density-structure", count = 250}

  local lds2 = game.get_entity_by_tag("lds2")
  lds2.insert{name = "low-density-structure", count = 250}

  local lds3 = game.get_entity_by_tag("lds3")
  lds3.insert{name = "low-density-structure", count = 250}

  local lds4 = game.get_entity_by_tag("lds4")
  lds4.insert{name = "low-density-structure", count = 250}

  local rf1 = game.get_entity_by_tag("rf1")
  rf1.insert{name = "rocket-fuel", count = 250}

  local rf2 = game.get_entity_by_tag("rf2")
  rf2.insert{name = "rocket-fuel", count = 250}

  local rf3 = game.get_entity_by_tag("rf3")
  rf3.insert{name = "rocket-fuel", count = 250}

  local rf4 = game.get_entity_by_tag("rf4")
  rf4.insert{name = "rocket-fuel", count = 250}

  local rcu1 = game.get_entity_by_tag("rcu1")
  rcu1.insert{name = "rocket-control-unit", count = 250}

  local rcu2 = game.get_entity_by_tag("rcu2")
  rcu2.insert{name = "rocket-control-unit", count = 250}

  local rcu3 = game.get_entity_by_tag("rcu3")
  rcu3.insert{name = "rocket-control-unit", count = 250}

  local rcu4 = game.get_entity_by_tag("rcu4")
  rcu4.insert{name = "rocket-control-unit", count = 250}

end)

  story_table =
  {
    {
      { action =
        function()
          story_show_message_dialog{text = {"msg-briefing-1"}}
          story_show_message_dialog{text = {"msg-briefing-2"}}

          local furnaces = game.surfaces[1].find_entities_filtered({name="steel-furnace"})
          for _, v in ipairs(furnaces) do
              v.insert{name="coal", count=10}
          end

          local turrets = game.surfaces[1].find_entities_filtered({name="gun-turret"})
          for _, v in ipairs(turrets) do
              v.insert{name="piercing-rounds-magazine", count=25}
          end

          local character = game.players[1].character
          character.insert{name = "iron-plate", count = 100}
          character.insert{name = "copper-plate", count = 50}
          character.insert{name = "steel-plate", count = 50} 
          character.insert{name = "electronic-circuit", count = 50}
          character.insert{name = "transport-belt", count = 200}
          character.insert{name = "splitter", count = 10}
          character.insert{name = "underground-belt", count = 20}
          character.insert{name = "inserter", count = 40}
          character.insert{name = "fast-inserter", count = 40}
          character.insert{name = "long-handed-inserter", count = 20}
          character.insert{name = "small-electric-pole", count = 40}
          character.insert{name = "medium-electric-pole", count = 40}
          character.insert{name = "wooden-chest", count = 20}
          character.insert{name = "electric-mining-drill", count = 20}
          character.insert{name = "steel-furnace", count = 20}
          character.insert{name = "assembling-machine-2", count = 20}
          character.insert{name = "small-lamp", count = 10}
          character.insert{name = "submachine-gun", count = 1}
          character.insert{name = "piercing-rounds-magazine", count = 80}
          character.insert{name = "grenade", count = 20}
          character.insert{name = "land-mine", count = 20}
          character.insert{name = "laser-turret", count = 8}
          character.insert{name = "gun-turret", count = 15}
          character.insert{name = "stone-wall", count = 200}
          character.insert{name = "steel-axe", count = 1}
          character.insert{name = "light-armor", count = 1}
          character.insert{name = "repair-pack", count = 20}
        end
      },
      { condition = story_elapsed_check(8),
        action =
        function()
          game.players[1].print({"msg-1-1"})
          game.forces.player.set_spawn_position(game.players[1].position, game.players[1].surface)
        end
      },
      {
        condition = story_elapsed_check(2),
        action =
        function()
          game.players[1].print({"msg-1-2"})
        end
      },      
      {
        condition = story_elapsed_check(2),
        action =
        function()
          story_show_message_dialog{text = {"msg-1-3"}}
        end
      },
      {
        condition = story_elapsed_check(2),
        action =
        function()
          game.players[1].print({"msg-1-4"})
        end
      },
      {
        condition = story_elapsed_check(2),
        action =
        function()
          set_goal({"goal-1"})
        end
      },
      { condition = function()
          return game.players[1].force.technologies["tanks"].researched and game.players[1].force.technologies["laser-turrets"].researched and game.players[1].force.technologies["flamethrower"].researched
        end,

        action = function()
          set_goal("")
          game.forces.enemy.evolution_factor = .6
          game.players[1].print({"msg-2-1"})

          local areschest = game.get_entity_by_tag("areschest")
          areschest.insert{name = "power-armor", count = 1}
          areschest.insert{name = "rocket-launcher", count = 1}
          areschest.insert{name = "rocket", count = 25}
          areschest.insert{name = "cannon-shell", count = 25}
          areschest.insert{name = "explosive-cannon-shell", count = 25}
          areschest.insert{name = "speed-module-3", count = 5}
          areschest.insert{name = "artillery-shell", count = 15}
          areschest.insert{name = "artillery-targeting-remote", count = 1}
        end

      },
      { condition = story_elapsed_check(2),

        action = function ()
          game.players[1].print({"msg-2-2"})
        end

      },
      { condition = story_elapsed_check(2),

        action = function ()
          story_show_message_dialog{text = {"msg-2-3"}}
        end

      },
      { condition = story_elapsed_check(2),

        action = function ()
          game.players[1].print({"msg-2-4"})
        end

      },
      { condition = story_elapsed_check(2),

        action = function()
          set_goal({"goal-2"})
          local artillery_gun = game.get_entity_by_tag("artillerygun")
          game.players[1].force.chart(game.players[1].surface, {{artillery_gun.position.x, artillery_gun.position.y-5}, {artillery_gun.position.x+2, artillery_gun.position.y+5}})
        end

      },
      { condition = function(event)
          return game.players[1].get_item_count("artillery-turret") >= 1
        end,

        action = function()
          set_goal("")
          game.forces.enemy.evolution_factor = .95
          game.players[1].print({"msg-3-1"})
        end

      },
      { condition = story_elapsed_check(2),

        action = function ()
          story_show_message_dialog{text = {"msg-3-2"}}
        end

      },
      { condition = story_elapsed_check(2),

        action = function ()
          game.players[1].print({"msg-3-3"})
        end

      },
      { condition = story_elapsed_check(2),

        action = function()
          set_goal({"goal-3"})
          local silo = game.get_entity_by_tag("silo")
          game.players[1].force.chart(game.players[1].surface, {{silo.position.x-5, silo.position.y-5}, {silo.position.x+5, silo.position.y+5}})
        end

      },
      { condition = function(event)
        return event.name == defines.events.on_rocket_launched and
               event.rocket.get_item_count("artillery-turret") > 0
        end,

        action = function()
            game.players[1].print({"msg-4-1"})
        end
      },
      { condition = story_elapsed_check(3)

      },
    }
  }
story_init_helpers(story_table)

script.on_event(defines.events, function(event)
  story_update(global.story, event)
end)
